Loading...
Searching...
No Matches
itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage > Class Template Reference

`#include <itkAdvancedImageToImageMetric.h>`

## Detailed Description

template<class TFixedImage, class TMovingImage>
class itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >

An extension of the ITK ImageToImageMetric. It is the intended base class for all elastix metrics.

This class inherits from the itk::ImageToImageMetric. The additional features of this class that makes it an AdvancedImageToImageMetric are:

- The use of an ImageSampler, which selects the fixed image samples over which the metric is evaluated. In the derived metric you simply need to loop over the image sample container, instead over the fixed image. This way it is easy to create different samplers, without the derived metric needing to know.
- Gray value limiters: for some metrics it is important to know the range of expected gray values in the fixed and moving image, beforehand. However, when a third order B-spline interpolator is used to interpolate the images, the interpolated values may be larger than the range of voxel values, because of so-called overshoot. The gray-value limiters make sure this doesn't happen.
- Fast implementation when a B-spline transform is used. The B-spline transform has a sparse Jacobian. The AdvancedImageToImageMetric provides functions that make it easier for inheriting metrics to exploit this fact.
- MovingImageDerivativeScales: an experimental option, which allows scaling of the moving image derivatives. This is a kind of fast hack, which makes it possible to avoid transformation in one direction (x, y, or z). Do not use this functionality unless you have a good reason for it...
- Some convenience functions are provided, such as the IsInsideMovingMask and CheckNumberOfSamples.

The parameters used in this class are:

Parameters
  MovingImageDerivativeScales: scale the moving image derivatives. Use
  (MovingImageDerivativeScales 1 1 0)
  to penalize deformations in the z-direction. The default value is that this feature is not used.

Definition at line 82 of file itkAdvancedImageToImageMetric.h.

Inheritance diagram for itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >:
[legend]

## Data Structures

struct | DummyMask
struct | GetValueAndDerivativePerThreadStruct
struct | MultiThreaderParameterType

## Public Types

using | AdvancedTransformType = AdvancedTransform<ScalarType, FixedImageDimension, MovingImageDimension>
using | BSplineOrder1TransformPointer = typename BSplineOrder1TransformType::Pointer
using | BSplineOrder1TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 1>
using | BSplineOrder2TransformPointer = typename BSplineOrder2TransformType::Pointer
using | BSplineOrder2TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 2>
using | BSplineOrder3TransformPointer = typename BSplineOrder3TransformType::Pointer
using | BSplineOrder3TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 3>
using | CombinationTransformType = AdvancedCombinationTransform<ScalarType, FixedImageDimension>
using | ConstPointer = SmartPointer<const Self>
using | DerivativeValueType = typename DerivativeType::ValueType
using | FixedImageLimiterOutputType = typename FixedImageLimiterType::OutputType
using | FixedImageLimiterPointer = typename FixedImageLimiterType::Pointer
using | FixedImageLimiterType = LimiterFunctionBase<RealType, FixedImageDimension>
using | FixedImageMaskConstPointer = SmartPointer<const FixedImageMaskType>
using | FixedImageMaskPointer = SmartPointer<FixedImageMaskType>
using | FixedImageMaskType = ImageMaskSpatialObject<Self::FixedImageDimension>
using | FixedImagePixelType = typename FixedImageType::PixelType
using | FixedImagePointer = typename FixedImageType::Pointer
using | ImageSampleContainerPointer = typename ImageSamplerType::OutputVectorContainerPointer
using | ImageSampleContainerType = typename ImageSamplerType::OutputVectorContainerType
using | ImageSamplerPointer = typename ImageSamplerType::Pointer
using | ImageSamplerType = ImageSamplerBase<FixedImageType>
using | MovingImageDerivativeScalesType = FixedArray<double, Self::MovingImageDimension>
using | MovingImageLimiterOutputType = typename MovingImageLimiterType::OutputType
using | MovingImageLimiterPointer = typename MovingImageLimiterType::Pointer
using | MovingImageLimiterType = LimiterFunctionBase<RealType, MovingImageDimension>
using | MovingImageMaskConstPointer = SmartPointer<const MovingImageMaskType>
using | MovingImageMaskPointer = SmartPointer<MovingImageMaskType>
using | MovingImageMaskType = ImageMaskSpatialObject<Self::MovingImageDimension>
using | MovingImagePointer = typename MovingImageType::Pointer
using | MovingImageRegionType = typename MovingImageType::RegionType
using | NumberOfParametersType = typename AdvancedTransformType::NumberOfParametersType
using | Pointer = SmartPointer<Self>
using | ScalarType = typename TransformType::ScalarType
using | Self = AdvancedImageToImageMetric
using | Superclass = ImageToImageMetric<TFixedImage, TMovingImage>
using | ThreadInfoType = MultiThreaderBase::WorkUnitInfo

## Public Member Functions

virtual void | BeforeThreadedGetValueAndDerivative (const TransformParametersType &parameters) const
virtual const char * | GetClassName () const
virtual const FixedImageLimiterType * | GetFixedImageLimiter ()
const FixedImageMaskType * | GetFixedImageMask () const override
virtual double | GetFixedLimitRangeRatio () const
ImageSamplerType * | GetImageSampler () const
virtual const MovingImageDerivativeScalesType & | GetMovingImageDerivativeScales ()
virtual const MovingImageLimiterType * | GetMovingImageLimiter ()
const MovingImageMaskType * | GetMovingImageMask () const override
virtual double | GetMovingLimitRangeRatio () const
virtual double | GetRequiredRatioOfValidSamples () const
virtual bool | GetScaleGradientWithRespectToMovingImageOrientation () const
const AdvancedTransformType * | GetTransform () const override
AdvancedTransformType * | GetTransform () override
virtual bool | GetUseFixedImageLimiter () const
virtual bool | GetUseImageSampler () const
virtual const bool & | GetUseMetricSingleThreaded ()
virtual bool | GetUseMovingImageDerivativeScales () const
virtual bool | GetUseMovingImageLimiter () const
virtual const bool & | GetUseMultiThread ()
void | Initialize () override
| ITK_DISALLOW_COPY_AND_MOVE (AdvancedImageToImageMetric)
| itkStaticConstMacro (FixedImageDimension, unsigned int, TFixedImage::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, TMovingImage::ImageDimension)
virtual void | SetFixedImageLimiter (FixedImageLimiterType *_arg)
virtual void | SetFixedImageMask (const FixedImageMaskType *const arg)
virtual void | SetFixedLimitRangeRatio (double _arg)
virtual void | SetImageSampler (ImageSamplerType *_arg)
virtual void | SetMovingImageDerivativeScales (MovingImageDerivativeScalesType _arg)
virtual void | SetMovingImageLimiter (MovingImageLimiterType *_arg)
virtual void | SetMovingImageMask (const MovingImageMaskType *const arg)
virtual void | SetMovingLimitRangeRatio (double _arg)
virtual void | SetRequiredRatioOfValidSamples (double _arg)
virtual void | SetScaleGradientWithRespectToMovingImageOrientation (bool _arg)
virtual void | SetTransform (AdvancedTransformType *arg)
virtual void | SetUseMetricSingleThreaded (bool _arg)
virtual void | SetUseMovingImageDerivativeScales (bool _arg)
virtual void | SetUseMultiThread (bool _arg)
virtual void | UseMetricSingleThreadedOff ()
virtual void | UseMetricSingleThreadedOn ()
virtual void | UseMultiThreadOff ()
virtual void | UseMultiThreadOn ()

## Protected Types

using | BSplineInterpolatorFloatPointer = typename BSplineInterpolatorFloatType::Pointer
using | BSplineInterpolatorFloatType
using | BSplineInterpolatorPointer = typename BSplineInterpolatorType::Pointer
using | BSplineInterpolatorType
using | FixedImageIndexType = typename FixedImageType::IndexType
using | FixedImageIndexValueType = typename FixedImageIndexType::IndexValueType
using | FixedImagePointType = typename TransformType::InputPointType
using | LinearInterpolatorPointer = typename LinearInterpolatorType::Pointer
using | LinearInterpolatorType = AdvancedLinearInterpolateImageFunction<MovingImageType, CoordinateRepresentationType>
using | MovingImageContinuousIndexType = typename InterpolatorType::ContinuousIndexType
using | MovingImageDerivativeType = typename BSplineInterpolatorType::CovariantVectorType
using | MovingImageIndexType = typename MovingImageType::IndexType
using | MovingImagePointType = typename TransformType::OutputPointType
using | NonZeroJacobianIndicesType = typename AdvancedTransformType::NonZeroJacobianIndicesType
using | ReducedBSplineInterpolatorPointer = typename ReducedBSplineInterpolatorType::Pointer
using | ReducedBSplineInterpolatorType

## Protected Member Functions

| AdvancedImageToImageMetric ()
virtual void | AfterThreadedGetValue (MeasureType &) const
virtual void | AfterThreadedGetValueAndDerivative (MeasureType &, DerivativeType &) const
void | CheckForAdvancedTransform ()
void | CheckForBSplineInterpolator ()
void | CheckForBSplineTransform () const
void | CheckNumberOfSamples (unsigned long wanted, unsigned long found) const
virtual bool | EvaluateMovingImageValueAndDerivative (const MovingImagePointType &mappedPoint, RealType &movingImageValue, MovingImageDerivativeType *gradient) const
bool | EvaluateTransformJacobian (const FixedImagePointType &fixedImagePoint, TransformJacobianType &jacobian, NonZeroJacobianIndicesType &nzji) const
virtual void | EvaluateTransformJacobianInnerProduct (const TransformJacobianType &jacobian, const MovingImageDerivativeType &movingImageDerivative, DerivativeType &imageJacobian) const
bool | FastEvaluateMovingImageValueAndDerivative (const MovingImagePointType &mappedPoint, RealType &movingImageValue, MovingImageDerivativeType *gradient, const ThreadIdType threadId) const
virtual void | InitializeImageSampler ()
void | InitializeLimiters ()
virtual void | InitializeThreadingParameters () const
virtual bool | IsInsideMovingMask (const MovingImagePointType &point) const
| itkAlignedTypedef (ITK_CACHE_LINE_ALIGNMENT, PaddedGetValueAndDerivativePerThreadStruct, AlignedGetValueAndDerivativePerThreadStruct)
| itkPadStruct (ITK_CACHE_LINE_ALIGNMENT, GetValueAndDerivativePerThreadStruct, PaddedGetValueAndDerivativePerThreadStruct)
void | LaunchGetValueAndDerivativeThreaderCallback () const
void | LaunchGetValueThreaderCallback () const
void | PrintSelf (std::ostream &os, Indent indent) const override
void | SetFixedImageMask (const typename Superclass::FixedImageMaskType *) final
void | SetFixedImageMask (typename Superclass::FixedImageMaskType *) final
void | SetMovingImageMask (const typename Superclass::MovingImageMaskType *) final
void | SetMovingImageMask (typename Superclass::MovingImageMaskType *) final
virtual void | SetUseFixedImageLimiter (bool _arg)
virtual void | SetUseImageSampler (bool _arg)
virtual void | SetUseMovingImageLimiter (bool _arg)
virtual void | ThreadedGetValue (ThreadIdType) const
virtual void | ThreadedGetValueAndDerivative (ThreadIdType) const
MovingImagePointType | TransformPoint (const FixedImagePointType &fixedImagePoint) const
| ~AdvancedImageToImageMetric () override=default

## Static Protected Member Functions

static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | AccumulateDerivativesThreaderCallback (void *arg)
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | GetValueAndDerivativeThreaderCallback (void *arg)
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | GetValueThreaderCallback (void *arg)

## Protected Attributes

AdvancedTransformType::Pointer | m_AdvancedTransform { nullptr }
FixedImageLimiterOutputType | m_FixedImageMaxLimit { 1 }
FixedImageLimiterOutputType | m_FixedImageMinLimit { 0 }
FixedImagePixelType | m_FixedImageTrueMax { 1 }
FixedImagePixelType | m_FixedImageTrueMin { 0 }
double | m_FixedLimitRangeRatio { 0.01 }
std::unique_ptr< AlignedGetValueAndDerivativePerThreadStruct[]> | m_GetValueAndDerivativePerThreadVariables
ThreadIdType | m_GetValueAndDerivativePerThreadVariablesSize { 0 }
ImageSamplerPointer | m_ImageSampler { nullptr }
MovingImageLimiterOutputType | m_MovingImageMaxLimit { 1 }
MovingImageLimiterOutputType | m_MovingImageMinLimit { 0 }
MovingImagePixelType | m_MovingImageTrueMax { 1 }
MovingImagePixelType | m_MovingImageTrueMin { 0 }
double | m_MovingLimitRangeRatio { 0.01 }
MultiThreaderParameterType | m_ThreaderMetricParameters {}
bool | m_TransformIsBSpline { false }
bool | m_UseMetricSingleThreaded { true }
bool | m_UseMultiThread { false }

## Private Member Functions

template<typename... TOptionalThreadId>
bool | EvaluateMovingImageValueAndDerivativeWithOptionalThreadId (const MovingImagePointType &mappedPoint, RealType &movingImageValue, MovingImageDerivativeType *gradient, const TOptionalThreadId... optionalThreadId) const

## Private Attributes

BSplineInterpolatorPointer | m_BSplineInterpolator { nullptr }
BSplineInterpolatorFloatPointer | m_BSplineInterpolatorFloat { nullptr }
FixedImageLimiterPointer | m_FixedImageLimiter { nullptr }
LinearInterpolatorPointer | m_LinearInterpolator { nullptr }
MovingImageDerivativeScalesType | m_MovingImageDerivativeScales { MovingImageDerivativeScalesType::Filled(1.0) }
MovingImageLimiterPointer | m_MovingImageLimiter { nullptr }
ReducedBSplineInterpolatorPointer | m_ReducedBSplineInterpolator { nullptr }
double | m_RequiredRatioOfValidSamples { 0.25 }
bool | m_ScaleGradientWithRespectToMovingImageOrientation { false }
bool | m_UseFixedImageLimiter { false }
bool | m_UseImageSampler { false }
bool | m_UseMovingImageDerivativeScales { false }
bool | m_UseMovingImageLimiter { false }

## Static Private Attributes

static constexpr DummyMask | m_FixedImageMask {}
static constexpr DummyMask | m_MovingImageMask {}

## Member Typedef Documentation

## AdvancedTransformType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::AdvancedTransformType = AdvancedTransform<ScalarType, FixedImageDimension, MovingImageDimension>

Definition at line 157 of file itkAdvancedImageToImageMetric.h.

## BSplineInterpolatorFloatPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BSplineInterpolatorFloatPointer = typename BSplineInterpolatorFloatType::Pointer

protected

Definition at line 347 of file itkAdvancedImageToImageMetric.h.

## BSplineInterpolatorFloatType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BSplineInterpolatorFloatType

protected

Initial value:
BSplineInterpolateImageFunction<MovingImageType, CoordinateRepresentationType, float>

Definition at line 345 of file itkAdvancedImageToImageMetric.h.

## BSplineInterpolatorPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BSplineInterpolatorPointer = typename BSplineInterpolatorType::Pointer

protected

Definition at line 344 of file itkAdvancedImageToImageMetric.h.

## BSplineInterpolatorType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BSplineInterpolatorType

protected

Initial value:
BSplineInterpolateImageFunction<MovingImageType, CoordinateRepresentationType, double>

Typedefs used for computing image derivatives.

Definition at line 342 of file itkAdvancedImageToImageMetric.h.

## BSplineOrder1TransformPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BSplineOrder1TransformPointer = typename BSplineOrder1TransformType::Pointer

Definition at line 165 of file itkAdvancedImageToImageMetric.h.

## BSplineOrder1TransformType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BSplineOrder1TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 1>

Definition at line 162 of file itkAdvancedImageToImageMetric.h.

## BSplineOrder2TransformPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BSplineOrder2TransformPointer = typename BSplineOrder2TransformType::Pointer

Definition at line 166 of file itkAdvancedImageToImageMetric.h.

## BSplineOrder2TransformType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BSplineOrder2TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 2>

Definition at line 163 of file itkAdvancedImageToImageMetric.h.

## BSplineOrder3TransformPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BSplineOrder3TransformPointer = typename BSplineOrder3TransformType::Pointer

Definition at line 167 of file itkAdvancedImageToImageMetric.h.

## BSplineOrder3TransformType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BSplineOrder3TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 3>

Definition at line 164 of file itkAdvancedImageToImageMetric.h.

## CombinationTransformType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::CombinationTransformType = AdvancedCombinationTransform<ScalarType, FixedImageDimension>

Typedef's for the B-spline transform.

Definition at line 161 of file itkAdvancedImageToImageMetric.h.

## ConstPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ConstPointer = SmartPointer<const Self>

Definition at line 91 of file itkAdvancedImageToImageMetric.h.

## DerivativeValueType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::DerivativeValueType = typename DerivativeType::ValueType

Definition at line 133 of file itkAdvancedImageToImageMetric.h.

## FixedImageIndexType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImageIndexType = typename FixedImageType::IndexType

protected

Protected Typedefs Typedefs for indices and points.

Definition at line 334 of file itkAdvancedImageToImageMetric.h.

## FixedImageIndexValueType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImageIndexValueType = typename FixedImageIndexType::IndexValueType

protected

Definition at line 335 of file itkAdvancedImageToImageMetric.h.

## FixedImageLimiterOutputType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImageLimiterOutputType = typename FixedImageLimiterType::OutputType

Definition at line 150 of file itkAdvancedImageToImageMetric.h.

## FixedImageLimiterPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImageLimiterPointer = typename FixedImageLimiterType::Pointer

Definition at line 149 of file itkAdvancedImageToImageMetric.h.

## FixedImageLimiterType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImageLimiterType = LimiterFunctionBase<RealType, FixedImageDimension>

Typedefs for Limiter support.

Definition at line 148 of file itkAdvancedImageToImageMetric.h.

## FixedImageMaskConstPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImageMaskConstPointer = SmartPointer<const FixedImageMaskType>

Definition at line 126 of file itkAdvancedImageToImageMetric.h.

## FixedImageMaskPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImageMaskPointer = SmartPointer<FixedImageMaskType>

Definition at line 125 of file itkAdvancedImageToImageMetric.h.

## FixedImageMaskType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImageMaskType = ImageMaskSpatialObject<Self::FixedImageDimension>

Definition at line 124 of file itkAdvancedImageToImageMetric.h.

## FixedImagePixelType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImagePixelType = typename FixedImageType::PixelType

Some useful extra typedefs.

Definition at line 137 of file itkAdvancedImageToImageMetric.h.

## FixedImagePointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImagePointer = typename FixedImageType::Pointer

Definition at line 107 of file itkAdvancedImageToImageMetric.h.

## FixedImagePointType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImagePointType = typename TransformType::InputPointType

protected

Definition at line 337 of file itkAdvancedImageToImageMetric.h.

## ImageSampleContainerPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ImageSampleContainerPointer = typename ImageSamplerType::OutputVectorContainerPointer

Definition at line 145 of file itkAdvancedImageToImageMetric.h.

## ImageSampleContainerType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ImageSampleContainerType = typename ImageSamplerType::OutputVectorContainerType

Definition at line 144 of file itkAdvancedImageToImageMetric.h.

## ImageSamplerPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ImageSamplerPointer = typename ImageSamplerType::Pointer

Definition at line 143 of file itkAdvancedImageToImageMetric.h.

## ImageSamplerType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ImageSamplerType = ImageSamplerBase<FixedImageType>

Typedefs for the ImageSampler.

Definition at line 142 of file itkAdvancedImageToImageMetric.h.

## LinearInterpolatorPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::LinearInterpolatorPointer = typename LinearInterpolatorType::Pointer

protected

Definition at line 352 of file itkAdvancedImageToImageMetric.h.

## LinearInterpolatorType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::LinearInterpolatorType = AdvancedLinearInterpolateImageFunction<MovingImageType, CoordinateRepresentationType>

protected

Definition at line 351 of file itkAdvancedImageToImageMetric.h.

## MovingImageContinuousIndexType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageContinuousIndexType = typename InterpolatorType::ContinuousIndexType

protected

Definition at line 339 of file itkAdvancedImageToImageMetric.h.

## MovingImageDerivativeScalesType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageDerivativeScalesType = FixedArray<double, Self::MovingImageDimension>

Definition at line 139 of file itkAdvancedImageToImageMetric.h.

## MovingImageDerivativeType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageDerivativeType = typename BSplineInterpolatorType::CovariantVectorType

protected

Definition at line 353 of file itkAdvancedImageToImageMetric.h.

## MovingImageIndexType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageIndexType = typename MovingImageType::IndexType

protected

Definition at line 336 of file itkAdvancedImageToImageMetric.h.

## MovingImageLimiterOutputType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageLimiterOutputType = typename MovingImageLimiterType::OutputType

Definition at line 153 of file itkAdvancedImageToImageMetric.h.

## MovingImageLimiterPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageLimiterPointer = typename MovingImageLimiterType::Pointer

Definition at line 152 of file itkAdvancedImageToImageMetric.h.

## MovingImageLimiterType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageLimiterType = LimiterFunctionBase<RealType, MovingImageDimension>

Definition at line 151 of file itkAdvancedImageToImageMetric.h.

## MovingImageMaskConstPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageMaskConstPointer = SmartPointer<const MovingImageMaskType>

Definition at line 129 of file itkAdvancedImageToImageMetric.h.

## MovingImageMaskPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageMaskPointer = SmartPointer<MovingImageMaskType>

Definition at line 128 of file itkAdvancedImageToImageMetric.h.

## MovingImageMaskType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageMaskType = ImageMaskSpatialObject<Self::MovingImageDimension>

Definition at line 127 of file itkAdvancedImageToImageMetric.h.

## MovingImagePointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImagePointer = typename MovingImageType::Pointer

Definition at line 104 of file itkAdvancedImageToImageMetric.h.

## MovingImagePointType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImagePointType = typename TransformType::OutputPointType

protected

Definition at line 338 of file itkAdvancedImageToImageMetric.h.

## MovingImageRegionType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageRegionType = typename MovingImageType::RegionType

Definition at line 138 of file itkAdvancedImageToImageMetric.h.

## NonZeroJacobianIndicesType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::NonZeroJacobianIndicesType = typename AdvancedTransformType::NonZeroJacobianIndicesType

protected

Typedefs for support of sparse Jacobians and compact support of transformations.

Definition at line 356 of file itkAdvancedImageToImageMetric.h.

## NumberOfParametersType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::NumberOfParametersType = typename AdvancedTransformType::NumberOfParametersType

Definition at line 158 of file itkAdvancedImageToImageMetric.h.

## Pointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::Pointer = SmartPointer<Self>

Definition at line 90 of file itkAdvancedImageToImageMetric.h.

## ReducedBSplineInterpolatorPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ReducedBSplineInterpolatorPointer = typename ReducedBSplineInterpolatorType::Pointer

protected

Definition at line 350 of file itkAdvancedImageToImageMetric.h.

## ReducedBSplineInterpolatorType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ReducedBSplineInterpolatorType

protected

Initial value:
ReducedDimensionBSplineInterpolateImageFunction<MovingImageType, CoordinateRepresentationType, double>
itk::ReducedDimensionBSplineInterpolateImageFunction
Evaluates the B-Spline interpolation of an image. Spline order may be from 0 to 5.
Definition itkReducedDimensionBSplineInterpolateImageFunction.h:87

Definition at line 348 of file itkAdvancedImageToImageMetric.h.

## ScalarType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ScalarType = typename TransformType::ScalarType

Advanced transform.

Definition at line 156 of file itkAdvancedImageToImageMetric.h.

## Self

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::Self = AdvancedImageToImageMetric

Standard class typedefs.

Definition at line 88 of file itkAdvancedImageToImageMetric.h.

## Superclass

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::Superclass = ImageToImageMetric<TFixedImage, TMovingImage>

Definition at line 89 of file itkAdvancedImageToImageMetric.h.

## ThreadInfoType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ThreadInfoType = MultiThreaderBase::WorkUnitInfo

Typedef for multi-threading.

Definition at line 170 of file itkAdvancedImageToImageMetric.h.

## Constructor & Destructor Documentation

## AdvancedImageToImageMetric()

template<class TFixedImage, class TMovingImage>

itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::AdvancedImageToImageMetric | ( |  | ) |

protected

Constructor.

## ~AdvancedImageToImageMetric()

template<class TFixedImage, class TMovingImage>

itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::~AdvancedImageToImageMetric | ( |  | ) |

override protected default

Destructor.

## Member Function Documentation

## AccumulateDerivativesThreaderCallback()

template<class TFixedImage, class TMovingImage>

ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::AccumulateDerivativesThreaderCallback | ( | void * | arg | ) |

static protected

AccumulateDerivatives threader callback function.

## AfterThreadedGetValue()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::AfterThreadedGetValue | ( | MeasureType & |  | ) | const

inline protected virtual

Finalize multi-threaded metric computation.

Reimplemented in itk::AdvancedMeanSquaresImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedMeanSquaresImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedMeanSquaresImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< TFixedImage, TMovingImage >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, and itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >.

Definition at line 388 of file itkAdvancedImageToImageMetric.h.

## AfterThreadedGetValueAndDerivative()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::AfterThreadedGetValueAndDerivative | ( | MeasureType & | ,
|  | DerivativeType & | ) const

inline protected virtual

Finalize multi-threaded metric computation.

Reimplemented in itk::AdvancedKappaStatisticImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedKappaStatisticImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedKappaStatisticImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::AdvancedMeanSquaresImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedMeanSquaresImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedMeanSquaresImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::AdvancedNormalizedCorrelationImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedNormalizedCorrelationImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedNormalizedCorrelationImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< TFixedImage, TMovingImage >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::TransformBendingEnergyPenaltyTerm< TFixedImage, TScalarType >, itk::TransformBendingEnergyPenaltyTerm< MetricBase< TElastix >::FixedImageType, double >, and itk::TransformBendingEnergyPenaltyTerm< typename MetricBase< TElastix >::FixedImageType, double >.

Definition at line 404 of file itkAdvancedImageToImageMetric.h.

## BeforeThreadedGetValueAndDerivative()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::BeforeThreadedGetValueAndDerivative | ( | const TransformParametersType & | parameters | ) | const

virtual

Contains calls from GetValueAndDerivative that are thread-unsafe, together with preparation for multi-threading. Note that the only reason why this function is not protected, is because the ComboMetric needs to call it.

Reimplemented in itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >, itk::TransformRigidityPenaltyTerm< MetricBase< TElastix >::FixedImageType, double >, and itk::TransformRigidityPenaltyTerm< typename MetricBase< TElastix >::FixedImageType, double >.

## CheckForAdvancedTransform()

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::CheckForAdvancedTransform | ( |  | ) |

protected

Methods to support transforms with sparse Jacobians, like the BSplineTransform Check if the transform is an AdvancedTransform. Called by Initialize. If so, we can speed up derivative calculations by only inspecting the parameters in the support region of a point.

## CheckForBSplineInterpolator()

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::CheckForBSplineInterpolator | ( |  | ) |

protected

Methods for image derivative evaluation support Initialize variables for image derivative computation; this method is called by Initialize.

## CheckForBSplineTransform()

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::CheckForBSplineTransform | ( |  | ) | const

protected

Check if the transform is a B-spline. Called by Initialize.

## CheckNumberOfSamples()

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::CheckNumberOfSamples | ( | unsigned long | wanted,
|  | unsigned long | found ) const

protected

Check if enough samples have been found to compute a reliable estimate of the value/derivative; throws an exception if not.

## EvaluateMovingImageValueAndDerivative()

template<class TFixedImage, class TMovingImage>

virtual bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::EvaluateMovingImageValueAndDerivative | ( | const MovingImagePointType & | mappedPoint,
|  | RealType & | movingImageValue,
|  | MovingImageDerivativeType * | gradient ) const

inline protected virtual

Compute the image value (and possibly derivative) at a transformed point. Checks if the point lies within the moving image buffer (bool return). If no gradient is wanted, set the gradient argument to 0. If a BSplineInterpolationFunction or AdvacnedLinearInterpolationFunction is used, this class obtains image derivatives from the B-spline or linear interpolator. Otherwise, image derivatives are computed using nearest neighbor interpolation of a precomputed (central difference) gradient image.

Reimplemented in itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >, itk::MultiInputImageToImageMetricBase< FixedImageType, MovingImageType >, and itk::MultiInputImageToImageMetricBase< TFixedImage, MetricBase< TElastix >::MovingImageType >.

Definition at line 500 of file itkAdvancedImageToImageMetric.h.

## EvaluateMovingImageValueAndDerivativeWithOptionalThreadId()

template<class TFixedImage, class TMovingImage>
template<typename... TOptionalThreadId>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::EvaluateMovingImageValueAndDerivativeWithOptionalThreadId | ( | const MovingImagePointType & | mappedPoint,
|  | RealType & | movingImageValue,
|  | MovingImageDerivativeType * | gradient,
|  | const TOptionalThreadId... | optionalThreadId ) const

private

## EvaluateTransformJacobian()

template<class TFixedImage, class TMovingImage>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::EvaluateTransformJacobian | ( | const FixedImagePointType & | fixedImagePoint,
|  | TransformJacobianType & | jacobian,
|  | NonZeroJacobianIndicesType & | nzji ) const

protected

This function returns a reference to the transform Jacobians. This is either a reference to the full TransformJacobian or a reference to a sparse Jacobians. The m_NonZeroJacobianIndices contains the indices that are nonzero. The length of NonZeroJacobianIndices is set in the CheckForAdvancedTransform function.

## EvaluateTransformJacobianInnerProduct()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::EvaluateTransformJacobianInnerProduct | ( | const TransformJacobianType & | jacobian,
|  | const MovingImageDerivativeType & | movingImageDerivative,
|  | DerivativeType & | imageJacobian ) const

protected virtual

Computes the inner product of transform Jacobian with moving image gradient. The results are stored in imageJacobian, which is supposed to have the right size (same length as Jacobian's number of columns).

Reimplemented in itk::PCAMetric2< TFixedImage, TMovingImage >, itk::PCAMetric2< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::PCAMetric2< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::PCAMetric< TFixedImage, TMovingImage >, itk::PCAMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::PCAMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::SumOfPairwiseCorrelationCoefficientsMetric< TFixedImage, TMovingImage >, itk::SumOfPairwiseCorrelationCoefficientsMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::SumOfPairwiseCorrelationCoefficientsMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< TFixedImage, TMovingImage >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::VarianceOverLastDimensionImageMetric< TFixedImage, TMovingImage >, itk::VarianceOverLastDimensionImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, and itk::VarianceOverLastDimensionImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >.

## FastEvaluateMovingImageValueAndDerivative()

template<class TFixedImage, class TMovingImage>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FastEvaluateMovingImageValueAndDerivative | ( | const MovingImagePointType & | mappedPoint,
|  | RealType & | movingImageValue,
|  | MovingImageDerivativeType * | gradient,
|  | const ThreadIdType | threadId ) const

inline protected

Definition at line 510 of file itkAdvancedImageToImageMetric.h.

## GetClassName()

template<class TFixedImage, class TMovingImage>

virtual const char * itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented in elastix::AdvancedKappaStatisticMetric< TElastix >, elastix::AdvancedMattesMutualInformationMetric< TElastix >, elastix::AdvancedMeanSquaresMetric< TElastix >, elastix::AdvancedNormalizedCorrelationMetric< TElastix >, elastix::DisplacementMagnitudePenalty< TElastix >, elastix::DistancePreservingRigidityPenalty< TElastix >, elastix::GradientDifferenceMetric< TElastix >, elastix::KNNGraphAlphaMutualInformationMetric< TElastix >, elastix::NormalizedGradientCorrelationMetric< TElastix >, elastix::NormalizedMutualInformationMetric< TElastix >, elastix::PatternIntensityMetric< TElastix >, elastix::PCAMetric2< TElastix >, elastix::PCAMetric< TElastix >, elastix::SumOfPairwiseCorrelationCoefficientsMetric< TElastix >, elastix::SumSquaredTissueVolumeDifferenceMetric< TElastix >, elastix::TransformBendingEnergyPenalty< TElastix >, elastix::TransformRigidityPenalty< TElastix >, elastix::VarianceOverLastDimensionMetric< TElastix >, itk::AdvancedKappaStatisticImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedKappaStatisticImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedKappaStatisticImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::AdvancedMeanSquaresImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedMeanSquaresImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedMeanSquaresImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::AdvancedNormalizedCorrelationImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedNormalizedCorrelationImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedNormalizedCorrelationImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::CombinationImageToImageMetric< TFixedImage, TMovingImage >, itk::CombinationImageToImageMetric< FixedImageType, MovingImageType >, itk::DisplacementMagnitudePenaltyTerm< TFixedImage, TScalarType >, itk::DisplacementMagnitudePenaltyTerm< MetricBase< TElastix >::FixedImageType, double >, itk::DisplacementMagnitudePenaltyTerm< typename MetricBase< TElastix >::FixedImageType, double >, itk::DistancePreservingRigidityPenaltyTerm< TFixedImage, TScalarType >, itk::DistancePreservingRigidityPenaltyTerm< MetricBase< TElastix >::FixedImageType, double >, itk::DistancePreservingRigidityPenaltyTerm< typename MetricBase< TElastix >::FixedImageType, double >, itk::GradientDifferenceImageToImageMetric< TFixedImage, TMovingImage >, itk::GradientDifferenceImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::GradientDifferenceImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::ImageToImageMetricWithFeatures< TFixedImage, TMovingImage, TFixedFeatureImage, TMovingFeatureImage >, itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >, itk::KNNGraphAlphaMutualInformationImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::KNNGraphAlphaMutualInformationImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >, itk::MultiInputImageToImageMetricBase< FixedImageType, MovingImageType >, itk::MultiInputImageToImageMetricBase< TFixedImage, MetricBase< TElastix >::MovingImageType >, itk::NormalizedGradientCorrelationImageToImageMetric< TFixedImage, TMovingImage >, itk::NormalizedGradientCorrelationImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::NormalizedGradientCorrelationImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::ParzenWindowHistogramImageToImageMetric< TFixedImage, TMovingImage >, itk::ParzenWindowHistogramImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::ParzenWindowMutualInformationImageToImageMetric< TFixedImage, TMovingImage >, itk::ParzenWindowMutualInformationImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::ParzenWindowMutualInformationImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::ParzenWindowNormalizedMutualInformationImageToImageMetric< TFixedImage, TMovingImage >, itk::ParzenWindowNormalizedMutualInformationImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::ParzenWindowNormalizedMutualInformationImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::PatternIntensityImageToImageMetric< TFixedImage, TMovingImage >, itk::PatternIntensityImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::PatternIntensityImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::PCAMetric2< TFixedImage, TMovingImage >, itk::PCAMetric2< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::PCAMetric2< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::PCAMetric< TFixedImage, TMovingImage >, itk::PCAMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::PCAMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::SumOfPairwiseCorrelationCoefficientsMetric< TFixedImage, TMovingImage >, itk::SumOfPairwiseCorrelationCoefficientsMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::SumOfPairwiseCorrelationCoefficientsMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< TFixedImage, TMovingImage >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::TransformBendingEnergyPenaltyTerm< TFixedImage, TScalarType >, itk::TransformBendingEnergyPenaltyTerm< MetricBase< TElastix >::FixedImageType, double >, itk::TransformBendingEnergyPenaltyTerm< typename MetricBase< TElastix >::FixedImageType, double >, itk::TransformPenaltyTerm< TFixedImage, TScalarType >, itk::TransformPenaltyTerm< MetricBase< TElastix >::FixedImageType, double >, itk::TransformPenaltyTerm< TFixedImage, TScalarType >, itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >, itk::TransformRigidityPenaltyTerm< MetricBase< TElastix >::FixedImageType, double >, itk::TransformRigidityPenaltyTerm< typename MetricBase< TElastix >::FixedImageType, double >, itk::VarianceOverLastDimensionImageMetric< TFixedImage, TMovingImage >, itk::VarianceOverLastDimensionImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, and itk::VarianceOverLastDimensionImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >.

## GetFixedImageLimiter()

template<class TFixedImage, class TMovingImage>

virtual const FixedImageLimiterType * itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetFixedImageLimiter | ( |  | ) |

virtual

## GetFixedImageMask()

template<class TFixedImage, class TMovingImage>

const FixedImageMaskType * itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetFixedImageMask | ( |  | ) | const

inline override

Definition at line 189 of file itkAdvancedImageToImageMetric.h.

## GetFixedLimitRangeRatio()

template<class TFixedImage, class TMovingImage>

virtual double itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetFixedLimitRangeRatio | ( |  | ) | const

virtual

## GetImageSampler()

template<class TFixedImage, class TMovingImage>

ImageSamplerType * itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetImageSampler | ( |  | ) | const

inline

Definition at line 235 of file itkAdvancedImageToImageMetric.h.

## GetMovingImageDerivativeScales()

template<class TFixedImage, class TMovingImage>

virtual const MovingImageDerivativeScalesType & itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetMovingImageDerivativeScales | ( |  | ) |

virtual

## GetMovingImageLimiter()

template<class TFixedImage, class TMovingImage>

virtual const MovingImageLimiterType * itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetMovingImageLimiter | ( |  | ) |

virtual

## GetMovingImageMask()

template<class TFixedImage, class TMovingImage>

const MovingImageMaskType * itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetMovingImageMask | ( |  | ) | const

inline override

Definition at line 197 of file itkAdvancedImageToImageMetric.h.

## GetMovingLimitRangeRatio()

template<class TFixedImage, class TMovingImage>

virtual double itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetMovingLimitRangeRatio | ( |  | ) | const

virtual

## GetRequiredRatioOfValidSamples()

template<class TFixedImage, class TMovingImage>

virtual double itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetRequiredRatioOfValidSamples | ( |  | ) | const

virtual

## GetScaleGradientWithRespectToMovingImageOrientation()

template<class TFixedImage, class TMovingImage>

virtual bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetScaleGradientWithRespectToMovingImageOrientation | ( |  | ) | const

virtual

## GetTransform() [1/2]

template<class TFixedImage, class TMovingImage>

const AdvancedTransformType * itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetTransform | ( |  | ) | const

inline override

Get the advanced transform. Const overload.

Definition at line 226 of file itkAdvancedImageToImageMetric.h.

## GetTransform() [2/2]

template<class TFixedImage, class TMovingImage>

AdvancedTransformType * itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetTransform | ( |  | ) |

inline override

Get the advanced transform.

Definition at line 219 of file itkAdvancedImageToImageMetric.h.

## GetUseFixedImageLimiter()

template<class TFixedImage, class TMovingImage>

virtual bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetUseFixedImageLimiter | ( |  | ) | const

virtual

Inheriting classes can specify whether they use the image limiter functionality. This method allows the user to inspect this setting.

## GetUseImageSampler()

template<class TFixedImage, class TMovingImage>

virtual bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetUseImageSampler | ( |  | ) | const

virtual

Inheriting classes can specify whether they use the image sampler functionality; This method allows the user to inspect this setting.

## GetUseMetricSingleThreaded()

template<class TFixedImage, class TMovingImage>

virtual const bool & itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetUseMetricSingleThreaded | ( |  | ) |

virtual

## GetUseMovingImageDerivativeScales()

template<class TFixedImage, class TMovingImage>

virtual bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetUseMovingImageDerivativeScales | ( |  | ) | const

virtual

## GetUseMovingImageLimiter()

template<class TFixedImage, class TMovingImage>

virtual bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetUseMovingImageLimiter | ( |  | ) | const

virtual

## GetUseMultiThread()

template<class TFixedImage, class TMovingImage>

virtual const bool & itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetUseMultiThread | ( |  | ) |

virtual

## GetValueAndDerivativeThreaderCallback()

template<class TFixedImage, class TMovingImage>

ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetValueAndDerivativeThreaderCallback | ( | void * | arg | ) |

static protected

GetValueAndDerivative threader callback function.

## GetValueThreaderCallback()

template<class TFixedImage, class TMovingImage>

ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::GetValueThreaderCallback | ( | void * | arg | ) |

static protected

GetValue threader callback function.

## Initialize()

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::Initialize | ( |  | ) |

override

Initialize the Metric by making sure that all the components are present and plugged together correctly.

- Call the superclass' implementation
- Cache the number of transform parameters
- Initialize the image sampler, if used.
- Check if a B-spline interpolator has been set
- Check if an AdvancedTransform has been set

## InitializeImageSampler()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::InitializeImageSampler | ( |  | ) |

protected virtual

Protected methods ************** Methods for image sampler support Initialize variables related to the image sampler; called by Initialize.

Reimplemented in itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >, itk::MultiInputImageToImageMetricBase< FixedImageType, MovingImageType >, and itk::MultiInputImageToImageMetricBase< TFixedImage, MetricBase< TElastix >::MovingImageType >.

## InitializeLimiters()

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::InitializeLimiters | ( |  | ) |

protected

Initialize the {Fixed,Moving}[True]{Max,Min}[Limit] and the {Fixed,Moving}ImageLimiter Only does something when Use{Fixed,Moving}Limiter is set to true;

## InitializeThreadingParameters()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::InitializeThreadingParameters | ( |  | ) | const

protected virtual

Initialize some multi-threading related parameters.

Reimplemented in itk::AdvancedKappaStatisticImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedKappaStatisticImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedKappaStatisticImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::AdvancedNormalizedCorrelationImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedNormalizedCorrelationImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedNormalizedCorrelationImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::CombinationImageToImageMetric< TFixedImage, TMovingImage >, itk::CombinationImageToImageMetric< FixedImageType, MovingImageType >, itk::ParzenWindowHistogramImageToImageMetric< TFixedImage, TMovingImage >, itk::ParzenWindowHistogramImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::PCAMetric< TFixedImage, TMovingImage >, itk::PCAMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, and itk::PCAMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >.

## IsInsideMovingMask()

template<class TFixedImage, class TMovingImage>

virtual bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::IsInsideMovingMask | ( | const MovingImagePointType & | point | ) | const

protected virtual

Convenience method: check if point is inside the moving mask.

Reimplemented in itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >, itk::MultiInputImageToImageMetricBase< FixedImageType, MovingImageType >, and itk::MultiInputImageToImageMetricBase< TFixedImage, MetricBase< TElastix >::MovingImageType >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TFixedImage, class TMovingImage>

itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ITK_DISALLOW_COPY_AND_MOVE | ( | AdvancedImageToImageMetric< TFixedImage, TMovingImage > |  | ) |

## itkAlignedTypedef()

template<class TFixedImage, class TMovingImage>

itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::itkAlignedTypedef | ( | ITK_CACHE_LINE_ALIGNMENT | ,
|  | PaddedGetValueAndDerivativePerThreadStruct | ,
|  | AlignedGetValueAndDerivativePerThreadStruct | )

protected

## itkPadStruct()

template<class TFixedImage, class TMovingImage>

itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::itkPadStruct | ( | ITK_CACHE_LINE_ALIGNMENT | ,
|  | GetValueAndDerivativePerThreadStruct | ,
|  | PaddedGetValueAndDerivativePerThreadStruct | )

protected

## itkStaticConstMacro() [1/2]

template<class TFixedImage, class TMovingImage>

itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::itkStaticConstMacro | ( | FixedImageDimension | ,
|  | unsigned int | ,
|  | TFixedImage::ImageDimension | )

## itkStaticConstMacro() [2/2]

template<class TFixedImage, class TMovingImage>

itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::itkStaticConstMacro | ( | MovingImageDimension | ,
|  | unsigned int | ,
|  | TMovingImage::ImageDimension | )

Constants for the image dimensions.

## LaunchGetValueAndDerivativeThreaderCallback()

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::LaunchGetValueAndDerivativeThreaderCallback | ( |  | ) | const

protected

Launch MultiThread GetValueAndDerivative.

## LaunchGetValueThreaderCallback()

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::LaunchGetValueThreaderCallback | ( |  | ) | const

protected

Launch MultiThread GetValue.

## PrintSelf()

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

PrintSelf.

## SetFixedImageLimiter()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetFixedImageLimiter | ( | FixedImageLimiterType * | _arg | ) |

virtual

## SetFixedImageMask() [1/3]

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetFixedImageMask | ( | const FixedImageMaskType *const | arg | ) |

inline virtual

Public methods

Reimplemented in itk::CombinationImageToImageMetric< TFixedImage, TMovingImage >, itk::CombinationImageToImageMetric< FixedImageType, MovingImageType >, itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >, and itk::MultiInputImageToImageMetricBase< FixedImageType, MovingImageType >.

Definition at line 175 of file itkAdvancedImageToImageMetric.h.

## SetFixedImageMask() [2/3]

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetFixedImageMask | ( | const typename Superclass::FixedImageMaskType * |  | ) |

inline final protected

Definition at line 580 of file itkAdvancedImageToImageMetric.h.

## SetFixedImageMask() [3/3]

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetFixedImageMask | ( | typename Superclass::FixedImageMaskType * |  | ) |

inline final protected

Definition at line 574 of file itkAdvancedImageToImageMetric.h.

## SetFixedLimitRangeRatio()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetFixedLimitRangeRatio | ( | double | _arg | ) |

virtual

## SetImageSampler()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetImageSampler | ( | ImageSamplerType * | _arg | ) |

virtual

Set/Get the image sampler.

## SetMovingImageDerivativeScales()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetMovingImageDerivativeScales | ( | MovingImageDerivativeScalesType | _arg | ) |

virtual

## SetMovingImageLimiter()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetMovingImageLimiter | ( | MovingImageLimiterType * | _arg | ) |

virtual

Set/Get the Moving/Fixed limiter. Its thresholds and bounds are set by the metric. Setting a limiter is only mandatory if GetUse{Fixed,Moving}Limiter() returns true.

## SetMovingImageMask() [1/3]

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetMovingImageMask | ( | const MovingImageMaskType *const | arg | ) |

inline virtual

Reimplemented in itk::CombinationImageToImageMetric< TFixedImage, TMovingImage >, itk::CombinationImageToImageMetric< FixedImageType, MovingImageType >, itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >, and itk::MultiInputImageToImageMetricBase< FixedImageType, MovingImageType >.

Definition at line 182 of file itkAdvancedImageToImageMetric.h.

## SetMovingImageMask() [2/3]

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetMovingImageMask | ( | const typename Superclass::MovingImageMaskType * |  | ) |

inline final protected

Definition at line 592 of file itkAdvancedImageToImageMetric.h.

## SetMovingImageMask() [3/3]

template<class TFixedImage, class TMovingImage>

void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetMovingImageMask | ( | typename Superclass::MovingImageMaskType * |  | ) |

inline final protected

Definition at line 586 of file itkAdvancedImageToImageMetric.h.

## SetMovingLimitRangeRatio()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetMovingLimitRangeRatio | ( | double | _arg | ) |

virtual

A percentage that defines how much the gray value range is extended maxlimit = max + LimitRangeRatio * (max - min) minlimit = min - LimitRangeRatio * (max - min) Default: 0.01; If you use a nearest neighbor or linear interpolator, set it to zero and use a hard limiter.

## SetRequiredRatioOfValidSamples()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetRequiredRatioOfValidSamples | ( | double | _arg | ) |

virtual

Set/Get the required ratio of valid samples; default 0.25. When less than this ratio*numberOfSamplesTried samples map inside the moving image buffer, an exception will be thrown.

## SetScaleGradientWithRespectToMovingImageOrientation()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetScaleGradientWithRespectToMovingImageOrientation | ( | bool | _arg | ) |

virtual

## SetTransform()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetTransform | ( | AdvancedTransformType * | arg | ) |

inline virtual

Set the transform, of advanced type.

Reimplemented in itk::CombinationImageToImageMetric< TFixedImage, TMovingImage >, and itk::CombinationImageToImageMetric< FixedImageType, MovingImageType >.

Definition at line 206 of file itkAdvancedImageToImageMetric.h.

## SetUseFixedImageLimiter()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetUseFixedImageLimiter | ( | bool | _arg | ) |

protected virtual

Inheriting classes can specify whether they use the image limiter functionality Make sure to set it before calling Initialize; default: false.

## SetUseImageSampler()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetUseImageSampler | ( | bool | _arg | ) |

protected virtual

Inheriting classes can specify whether they use the image sampler functionality Make sure to set it before calling Initialize; default: false.

## SetUseMetricSingleThreaded()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetUseMetricSingleThreaded | ( | bool | _arg | ) |

virtual

Switch the function BeforeThreadedGetValueAndDerivative on or off.

## SetUseMovingImageDerivativeScales()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetUseMovingImageDerivativeScales | ( | bool | _arg | ) |

virtual

You may specify a scaling vector for the moving image derivatives. If the UseMovingImageDerivativeScales is true, the moving image derivatives are multiplied by the moving image derivative scales (element-wise) You may use this to avoid deformations in the z-dimension, for example, by setting the moving image derivative scales to (1,1,0). This is a rather experimental feature. In most cases you do not need it.

## SetUseMovingImageLimiter()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetUseMovingImageLimiter | ( | bool | _arg | ) |

protected virtual

## SetUseMultiThread()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::SetUseMultiThread | ( | bool | _arg | ) |

virtual

Select the use of multi-threading

## ThreadedGetValue()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ThreadedGetValue | ( | ThreadIdType |  | ) | const

inline protected virtual

Multi-threaded metric computation. Multi-threaded version of GetValue().

Reimplemented in itk::AdvancedMeanSquaresImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedMeanSquaresImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedMeanSquaresImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< TFixedImage, TMovingImage >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, and itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >.

Definition at line 384 of file itkAdvancedImageToImageMetric.h.

## ThreadedGetValueAndDerivative()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::ThreadedGetValueAndDerivative | ( | ThreadIdType |  | ) | const

inline protected virtual

Multi-threaded version of GetValueAndDerivative().

Reimplemented in itk::AdvancedKappaStatisticImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedKappaStatisticImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedKappaStatisticImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::AdvancedMeanSquaresImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedMeanSquaresImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedMeanSquaresImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::AdvancedNormalizedCorrelationImageToImageMetric< TFixedImage, TMovingImage >, itk::AdvancedNormalizedCorrelationImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::AdvancedNormalizedCorrelationImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< TFixedImage, TMovingImage >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< MetricBase< TElastix >::FixedImageType, MetricBase< TElastix >::MovingImageType >, itk::SumSquaredTissueVolumeDifferenceImageToImageMetric< typename MetricBase< TElastix >::FixedImageType, typename MetricBase< TElastix >::MovingImageType >, itk::TransformBendingEnergyPenaltyTerm< TFixedImage, TScalarType >, itk::TransformBendingEnergyPenaltyTerm< MetricBase< TElastix >::FixedImageType, double >, and itk::TransformBendingEnergyPenaltyTerm< typename MetricBase< TElastix >::FixedImageType, double >.

Definition at line 400 of file itkAdvancedImageToImageMetric.h.

## TransformPoint()

template<class TFixedImage, class TMovingImage>

MovingImagePointType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::TransformPoint | ( | const FixedImagePointType & | fixedImagePoint | ) | const

protected

Transform a point from FixedImage domain to MovingImage domain.

## UseMetricSingleThreadedOff()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::UseMetricSingleThreadedOff | ( |  | ) |

virtual

## UseMetricSingleThreadedOn()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::UseMetricSingleThreadedOn | ( |  | ) |

virtual

## UseMultiThreadOff()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::UseMultiThreadOff | ( |  | ) |

virtual

## UseMultiThreadOn()

template<class TFixedImage, class TMovingImage>

virtual void itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::UseMultiThreadOn | ( |  | ) |

virtual

## Field Documentation

## m_AdvancedTransform

template<class TFixedImage, class TMovingImage>

AdvancedTransformType::Pointer itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_AdvancedTransform { nullptr }

protected

Variables to store the AdvancedTransform.

Definition at line 366 of file itkAdvancedImageToImageMetric.h.

## m_BSplineInterpolator

template<class TFixedImage, class TMovingImage>

BSplineInterpolatorPointer itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_BSplineInterpolator { nullptr }

private

Definition at line 612 of file itkAdvancedImageToImageMetric.h.

## m_BSplineInterpolatorFloat

template<class TFixedImage, class TMovingImage>

BSplineInterpolatorFloatPointer itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_BSplineInterpolatorFloat { nullptr }

private

Definition at line 613 of file itkAdvancedImageToImageMetric.h.

## m_FixedImageLimiter

template<class TFixedImage, class TMovingImage>

FixedImageLimiterPointer itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_FixedImageLimiter { nullptr }

private

Private member variables for limiters and for image derivative computation.

Definition at line 609 of file itkAdvancedImageToImageMetric.h.

## m_FixedImageMask

template<class TFixedImage, class TMovingImage>

DummyMask itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_FixedImageMask {}

static constexpr private

Definition at line 633 of file itkAdvancedImageToImageMetric.h.

## m_FixedImageMaxLimit

template<class TFixedImage, class TMovingImage>

FixedImageLimiterOutputType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_FixedImageMaxLimit { 1 }

protected

Definition at line 377 of file itkAdvancedImageToImageMetric.h.

## m_FixedImageMinLimit

template<class TFixedImage, class TMovingImage>

FixedImageLimiterOutputType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_FixedImageMinLimit { 0 }

protected

Definition at line 376 of file itkAdvancedImageToImageMetric.h.

## m_FixedImageTrueMax

template<class TFixedImage, class TMovingImage>

FixedImagePixelType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_FixedImageTrueMax { 1 }

protected

Definition at line 373 of file itkAdvancedImageToImageMetric.h.

## m_FixedImageTrueMin

template<class TFixedImage, class TMovingImage>

FixedImagePixelType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_FixedImageTrueMin { 0 }

protected

Variables for the Limiters.

Definition at line 372 of file itkAdvancedImageToImageMetric.h.

## m_FixedLimitRangeRatio

template<class TFixedImage, class TMovingImage>

double itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_FixedLimitRangeRatio { 0.01 }

protected

Definition at line 569 of file itkAdvancedImageToImageMetric.h.

## m_GetValueAndDerivativePerThreadVariables

template<class TFixedImage, class TMovingImage>

std::unique_ptr<AlignedGetValueAndDerivativePerThreadStruct[]> itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_GetValueAndDerivativePerThreadVariables

mutable protected

Initial value:
{
nullptr
}

Definition at line 458 of file itkAdvancedImageToImageMetric.h.

## m_GetValueAndDerivativePerThreadVariablesSize

template<class TFixedImage, class TMovingImage>

ThreadIdType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_GetValueAndDerivativePerThreadVariablesSize { 0 }

mutable protected

Definition at line 461 of file itkAdvancedImageToImageMetric.h.

## m_ImageSampler

template<class TFixedImage, class TMovingImage>

ImageSamplerPointer itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_ImageSampler { nullptr }

mutable protected

Protected Variables Variables for ImageSampler support. m_ImageSampler is mutable, because it is changed in the GetValue(), etc, which are const functions.

Definition at line 363 of file itkAdvancedImageToImageMetric.h.

## m_LinearInterpolator

template<class TFixedImage, class TMovingImage>

LinearInterpolatorPointer itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_LinearInterpolator { nullptr }

private

Definition at line 611 of file itkAdvancedImageToImageMetric.h.

## m_MovingImageDerivativeScales

template<class TFixedImage, class TMovingImage>

MovingImageDerivativeScalesType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_MovingImageDerivativeScales { MovingImageDerivativeScalesType::Filled(1.0) }

private

Definition at line 624 of file itkAdvancedImageToImageMetric.h.

## m_MovingImageLimiter

template<class TFixedImage, class TMovingImage>

MovingImageLimiterPointer itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_MovingImageLimiter { nullptr }

private

Definition at line 610 of file itkAdvancedImageToImageMetric.h.

## m_MovingImageMask

template<class TFixedImage, class TMovingImage>

DummyMask itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_MovingImageMask {}

static constexpr private

Definition at line 634 of file itkAdvancedImageToImageMetric.h.

## m_MovingImageMaxLimit

template<class TFixedImage, class TMovingImage>

MovingImageLimiterOutputType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_MovingImageMaxLimit { 1 }

protected

Definition at line 379 of file itkAdvancedImageToImageMetric.h.

## m_MovingImageMinLimit

template<class TFixedImage, class TMovingImage>

MovingImageLimiterOutputType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_MovingImageMinLimit { 0 }

protected

Definition at line 378 of file itkAdvancedImageToImageMetric.h.

## m_MovingImageTrueMax

template<class TFixedImage, class TMovingImage>

MovingImagePixelType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_MovingImageTrueMax { 1 }

protected

Definition at line 375 of file itkAdvancedImageToImageMetric.h.

## m_MovingImageTrueMin

template<class TFixedImage, class TMovingImage>

MovingImagePixelType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_MovingImageTrueMin { 0 }

protected

Definition at line 374 of file itkAdvancedImageToImageMetric.h.

## m_MovingLimitRangeRatio

template<class TFixedImage, class TMovingImage>

double itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_MovingLimitRangeRatio { 0.01 }

protected

Definition at line 570 of file itkAdvancedImageToImageMetric.h.

## m_ReducedBSplineInterpolator

template<class TFixedImage, class TMovingImage>

ReducedBSplineInterpolatorPointer itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_ReducedBSplineInterpolator { nullptr }

private

Definition at line 614 of file itkAdvancedImageToImageMetric.h.

## m_RequiredRatioOfValidSamples

template<class TFixedImage, class TMovingImage>

double itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_RequiredRatioOfValidSamples { 0.25 }

private

Definition at line 620 of file itkAdvancedImageToImageMetric.h.

## m_ScaleGradientWithRespectToMovingImageOrientation

template<class TFixedImage, class TMovingImage>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_ScaleGradientWithRespectToMovingImageOrientation { false }

private

Definition at line 622 of file itkAdvancedImageToImageMetric.h.

## m_ThreaderMetricParameters

template<class TFixedImage, class TMovingImage>

MultiThreaderParameterType itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_ThreaderMetricParameters {}

mutable protected

Definition at line 434 of file itkAdvancedImageToImageMetric.h.

## m_TransformIsBSpline

template<class TFixedImage, class TMovingImage>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_TransformIsBSpline { false }

mutable protected

Member variable for TransformPenaltyTerm::CheckForBSplineTransform2

Definition at line 369 of file itkAdvancedImageToImageMetric.h.

## m_UseFixedImageLimiter

template<class TFixedImage, class TMovingImage>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_UseFixedImageLimiter { false }

private

Definition at line 618 of file itkAdvancedImageToImageMetric.h.

## m_UseImageSampler

template<class TFixedImage, class TMovingImage>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_UseImageSampler { false }

private

Other private member variables.

Definition at line 617 of file itkAdvancedImageToImageMetric.h.

## m_UseMetricSingleThreaded

template<class TFixedImage, class TMovingImage>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_UseMetricSingleThreaded { true }

protected

Variables for multi-threading.

Definition at line 420 of file itkAdvancedImageToImageMetric.h.

## m_UseMovingImageDerivativeScales

template<class TFixedImage, class TMovingImage>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_UseMovingImageDerivativeScales { false }

private

Definition at line 621 of file itkAdvancedImageToImageMetric.h.

## m_UseMovingImageLimiter

template<class TFixedImage, class TMovingImage>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_UseMovingImageLimiter { false }

private

Definition at line 619 of file itkAdvancedImageToImageMetric.h.

## m_UseMultiThread

template<class TFixedImage, class TMovingImage>

bool itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::m_UseMultiThread { false }

protected

Definition at line 421 of file itkAdvancedImageToImageMetric.h.

Generated on 1768596610 for elastix by 1.15.0 |